"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var namings = require("./namings");
var descriptions_1 = require("./descriptions");
var js_restful_1 = require("js-restful");
/**
 * Specify a view name for a method. The result will of the method will be used to
 * render the view. Everything that can be handled and is configured by express can
 * be used to render the view. For example a jade template.
 *
 * @param viewName The viewName for the method.
 * @returns the decorated function
 */
function RenderWith(viewName) {
    return function (target, propertyKey, descriptor) {
        return Reflect.defineMetadata(namings.renderWith, viewName, descriptor.value);
    };
}
exports.RenderWith = RenderWith;
function ExpressContext(contextType) { return js_restful_1.DecoratorUtil.createParamDecorator(descriptions_1.ExpressContextType[contextType], namings.expressContextParam); }
exports.ExpressContext = ExpressContext;
//# sourceMappingURL=decorators.js.map