"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var chai_1 = require("chai");
var namings = require("./namings");
var decorators_1 = require("./decorators");
var descriptions_1 = require("./descriptions");
var js_restful_1 = require("js-restful");
var TestService = (function () {
    function TestService() {
    }
    TestService.prototype.render = function () {
    };
    TestService.prototype.nextFunction = function (next) {
    };
    __decorate([
        decorators_1.RenderWith('view'),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], TestService.prototype, "render", null);
    __decorate([
        js_restful_1.GET(),
        __param(0, decorators_1.ExpressContext(descriptions_1.ExpressContextType.HttpNextFunction)),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Function]),
        __metadata("design:returntype", void 0)
    ], TestService.prototype, "nextFunction", null);
    return TestService;
}());
describe('decorators', function () {
    var testService = new TestService();
    describe('RenderWith', function () {
        it('should have a decorator RenderWith at method render', function () {
            chai_1.expect(Reflect.getMetadata(namings.renderWith, testService.render)).to.eql('view');
        });
    });
    describe('ExpressContext', function () {
        it('should have a method with a next Function', function () {
            var contextParams = Reflect.getMetadata(namings.expressContextParam, testService, 'nextFunction');
            chai_1.expect(contextParams.length).to.equal(1);
            chai_1.expect(contextParams).to.contains({ paramName: 'HttpNextFunction', index: 0 });
        });
    });
});
//# sourceMappingURL=decorators.spec.js.map