"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var registry_1 = require("./registry");
var express = require("express");
var chai_1 = require("chai");
var request = require("supertest");
var js_restful_1 = require("js-restful");
var util = require("./test-util.spec");
var anyBook = { name: 'simsons' };
var TestService = (function () {
    function TestService() {
    }
    TestService.prototype.get = function () {
        return true;
    };
    __decorate([
        js_restful_1.GET(),
        js_restful_1.Path('/get'),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], TestService.prototype, "get", null);
    TestService = __decorate([
        js_restful_1.Path('/')
    ], TestService);
    return TestService;
}());
var TestServiceB = (function () {
    function TestServiceB() {
    }
    TestServiceB.prototype.get = function () {
        return true;
    };
    __decorate([
        js_restful_1.GET(),
        js_restful_1.Path('/get'),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], TestServiceB.prototype, "get", null);
    TestServiceB = __decorate([
        js_restful_1.Path('/b'),
        js_restful_1.PermitAll()
    ], TestServiceB);
    return TestServiceB;
}());
var TestServiceC = (function () {
    function TestServiceC() {
    }
    TestServiceC.prototype.get = function () {
        return true;
    };
    __decorate([
        js_restful_1.GET(),
        js_restful_1.Path('/get'),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], TestServiceC.prototype, "get", null);
    TestServiceC = __decorate([
        js_restful_1.Path('/c'),
        js_restful_1.RolesAllowed(['user'])
    ], TestServiceC);
    return TestServiceC;
}());
var TestServiceD = (function () {
    function TestServiceD() {
    }
    TestServiceD.prototype.get = function () {
        return true;
    };
    __decorate([
        js_restful_1.GET(),
        js_restful_1.Path('/get'),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], TestServiceD.prototype, "get", null);
    TestServiceD = __decorate([
        js_restful_1.Path('/d'),
        js_restful_1.RolesAllowed(['admin'])
    ], TestServiceD);
    return TestServiceD;
}());
var TestServiceE = (function () {
    function TestServiceE() {
    }
    TestServiceE.prototype.get = function () {
        return true;
    };
    __decorate([
        js_restful_1.GET(),
        js_restful_1.Path('/get'),
        js_restful_1.PermitAll(),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], TestServiceE.prototype, "get", null);
    TestServiceE = __decorate([
        js_restful_1.Path('/e')
    ], TestServiceE);
    return TestServiceE;
}());
var TestServiceF = (function () {
    function TestServiceF() {
    }
    TestServiceF.prototype.get = function () {
        return true;
    };
    __decorate([
        js_restful_1.GET(),
        js_restful_1.Path('/get'),
        js_restful_1.RolesAllowed(['user']),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], TestServiceF.prototype, "get", null);
    TestServiceF = __decorate([
        js_restful_1.Path('/f')
    ], TestServiceF);
    return TestServiceF;
}());
var TestServiceG = (function () {
    function TestServiceG() {
    }
    TestServiceG.prototype.get = function () {
        return true;
    };
    __decorate([
        js_restful_1.GET(),
        js_restful_1.Path('/get'),
        js_restful_1.RolesAllowed(['admin']),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], TestServiceG.prototype, "get", null);
    TestServiceG = __decorate([
        js_restful_1.Path('/g')
    ], TestServiceG);
    return TestServiceG;
}());
describe('registry-security', function () {
    var app;
    var testService;
    beforeEach(function () {
        app = express();
        var registry = new registry_1.JsRestfulRegistry(app);
        registry.registerSecurityContextFactory(new util.Factory());
        registry.registerService(new TestService());
        registry.registerService(new TestServiceB());
        registry.registerService(new TestServiceC());
        registry.registerService(new TestServiceD());
        registry.registerService(new TestServiceE());
        registry.registerService(new TestServiceF());
        registry.registerService(new TestServiceG());
    });
    it('should allow access to undecorated service/method', function (done) {
        request.agent(app).get('/get').end(function (err, res) {
            chai_1.expect(res.status).to.equal(200);
            chai_1.expect(res.text).to.eql('true');
            done();
        });
    });
    it('should allow access to permitAll at class level service/method', function (done) {
        request.agent(app).get('/b/get').end(function (err, res) {
            chai_1.expect(res.status).to.equal(200);
            chai_1.expect(res.text).to.eql('true');
            done();
        });
    });
    it('should allow access to allowedRoles user at class level service/method', function (done) {
        request.agent(app).get('/c/get').end(function (err, res) {
            chai_1.expect(res.status).to.equal(200);
            chai_1.expect(res.text).to.eql('true');
            done();
        });
    });
    it('should allow deny access to allowedRoles user at class level service/method', function (done) {
        request.agent(app).get('/d/get').end(function (err, res) {
            chai_1.expect(res.status).to.equal(403);
            chai_1.expect(res.text).to.eql('permission denied');
            done();
        });
    });
    it('should allow access to permitAll  at method level service/method', function (done) {
        request.agent(app).get('/e/get').end(function (err, res) {
            chai_1.expect(res.status).to.equal(200);
            chai_1.expect(res.text).to.eql('true');
            done();
        });
    });
    it('should allow access to rolesAllowed  at method level service/method', function (done) {
        request.agent(app).get('/f/get').end(function (err, res) {
            chai_1.expect(res.status).to.equal(200);
            chai_1.expect(res.text).to.eql('true');
            done();
        });
    });
    it('should allow deny access to allowedRoles user at method level service/method', function (done) {
        request.agent(app).get('/g/get').end(function (err, res) {
            chai_1.expect(res.status).to.equal(403);
            chai_1.expect(res.text).to.eql('permission denied');
            done();
        });
    });
});
//# sourceMappingURL=registry-sec.spec.js.map