import { MethodDescription } from 'js-restful';
import * as express from 'express';
import * as winston from 'winston';
import { ISecurityContextFactory } from './descriptions';
export interface JsRestfulRegistryConfig {
    logger?: winston.Winston | winston.LoggerInstance;
}
export declare class JsRestfulRegistry {
    private app;
    private config;
    private registeredServices;
    private securityContextFactory;
    constructor(app: express.Application, config?: JsRestfulRegistryConfig);
    registerSecurityContextFactory(factory: ISecurityContextFactory): void;
    registerService(service: any): void;
    collectAndConvertArgs(req: express.Request, res: express.Response, next: express.NextFunction, service: Object, method: MethodDescription): any[];
    convertRawParamToMethodParam(service: any, method: any, pathParam: any, rawParam: any): any;
}
